/*******************************************************************************
 * FoxTeamBalance generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxTeamBalance extends Object
    native;

struct native PCGroup
{
    var array<FoxPC> PCList;
    var float SkillRating;
    var bool bOnBestFitTeam;
    var int GroupSize;
    var string ClanTag;
    var int PartyIndex;

    structdefaultproperties
    {
        PCList=none
        SkillRating=0.0
        bOnBestFitTeam=false
        GroupSize=0
        ClanTag=""
        PartyIndex=0
    }
};

var array<FoxPC> PCList;
var array<PCGroup> GroupList;
var const float MaxSkillDifference;
var bool bForceAcceptTeam;
var float MostSkilledPlayer;
var int LoopCounter;
var array<PartyList> Parties;
var int MaxPartySize;
var delegate<PCGroupSortDelegate> __PCGroupSortDelegate__Delegate;

function AssignGroups(bool bGroupClans, bool bGroupParties)
{
    local int I, J;
    local string ClanTag;
    local bool bGroupFound;
    local PCGroup PCG;
    local int PartyIndex;
    local FoxPC PC;
    local FoxPRI PRI;

    I = 0;
    J0x0B:
    // End:0x526 [Loop If]
    if(I < PCList.Length)
    {
        PartyIndex = -1;
        bGroupFound = false;
        PC = PCList[I];
        PRI = FoxPRI(PC.PlayerReplicationInfo);
        ClanTag = PRI.ClanTag;
        // End:0x21C
        if(bGroupParties && IsPlayerInParty(PC, PartyIndex))
        {
            J = 0;
            J0xED:
            // End:0x21C [Loop If]
            if(J < GroupList.Length)
            {
                // End:0x20E
                if(GroupList[J].PartyIndex == PartyIndex)
                {
                    GroupList[J].PCList[GroupList[J].PCList.Length] = PC;
                    GroupList[J].SkillRating += PRI.Skill;
                    ++ GroupList[J].GroupSize;
                    bGroupFound = true;
                    // [Explicit Break]
                    goto J0x21C;
                }
                ++ J;
                J0x21C:
                // [Loop Continue]
                goto J0xED;
            }
        }
        // End:0x386
        if((!bGroupFound && bGroupClans) && ClanTag != "")
        {
            J = 0;
            J0x257:
            // End:0x386 [Loop If]
            if(J < GroupList.Length)
            {
                // End:0x378
                if(GroupList[J].ClanTag == ClanTag)
                {
                    GroupList[J].PCList[GroupList[J].PCList.Length] = PC;
                    GroupList[J].SkillRating += PRI.Skill;
                    ++ GroupList[J].GroupSize;
                    bGroupFound = true;
                    // [Explicit Break]
                    goto J0x386;
                }
                ++ J;
                J0x386:
                // [Loop Continue]
                goto J0x257;
            }
        }
        // End:0x4C4
        if(!bGroupFound)
        {
            PCG.PCList.Length = 0;
            PCG.PCList[0] = PC;
            PCG.SkillRating = PRI.Skill;
            PCG.GroupSize = 1;
            PCG.ClanTag = ((PartyIndex < 0) ? ClanTag : "Party" $ string(PartyIndex));
            PCG.PartyIndex = PartyIndex;
            GroupList[GroupList.Length] = PCG;
        }
        // End:0x518
        if(PRI.Skill > MostSkilledPlayer)
        {
            MostSkilledPlayer = PRI.Skill;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    I = 0;
    J0x531:
    // End:0x557 [Loop If]
    if(I < GroupList.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x531;
    }
    // End:0x8DF
    if(bGroupParties)
    {
        // End:0x8DF
        if(MaxPartySize > 1)
        {
            I = 0;
            J0x57E:
            // End:0x8DF [Loop If]
            if(I < GroupList.Length)
            {
                // End:0x8D1
                if((GroupList[I].PartyIndex > -1) && GroupList[I].PCList.Length > MaxPartySize)
                {
                    J = 1;
                    J0x608:
                    // End:0x81C [Loop If]
                    if(J < GroupList[I].PCList.Length)
                    {
                        PartyIndex = -1;
                        PC = GroupList[I].PCList[J];
                        PRI = FoxPRI(PC.PlayerReplicationInfo);
                        ClanTag = PRI.ClanTag;
                        PCG.PCList.Length = 0;
                        PCG.PCList[0] = PC;
                        PCG.SkillRating = PRI.Skill;
                        PCG.GroupSize = 1;
                        PCG.ClanTag = ((PartyIndex < 0) ? ClanTag : "Party" $ string(PartyIndex));
                        PCG.PartyIndex = PartyIndex;
                        GroupList[GroupList.Length] = PCG;
                        ++ J;
                        // [Loop Continue]
                        goto J0x608;
                    }
                    PC = GroupList[I].PCList[0];
                    GroupList[I].PCList.Length = 0;
                    GroupList[I].PCList[0] = PC;
                    GroupList[I].GroupSize = 1;
                }
                ++ I;
                // [Loop Continue]
                goto J0x57E;
            }
        }
    }
    I = 0;
    J0x8EA:
    // End:0x910 [Loop If]
    if(I < GroupList.Length)
    {
        ++ I;
        // [Loop Continue]
        goto J0x8EA;
    }
    //return;    
}

function bool IsPlayerInParty(FoxPC InPC, out int OutPartyIndex)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x9D [Loop If]
    if(I < Parties.Length)
    {
        // End:0x8F
        if(Parties[I].PartyMembers.Find(FoxPRI(InPC.PlayerReplicationInfo)) >= 0)
        {
            OutPartyIndex = I;
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return false;
    //return ReturnValue;    
}

function SplitIntoTeams()
{
    local int I, J, GameSize, BreakGroupSize;
    local float TotalSkill;
    local bool bBalanceSuccessfull;
    local PCGroup PCG;
    local array<int> BestTeam;

    I = 0;
    J0x0B:
    // End:0x93 [Loop If]
    if(I < GroupList.Length)
    {
        GameSize += GroupList[I].GroupSize;
        TotalSkill += GroupList[I].SkillRating;
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    GroupList.Sort(PCGroupSortDelegate);
    J0xBA:
    // End:0x3AB [Loop If]
    if(!bBalanceSuccessfull)
    {
        // End:0xF9
        if(GroupList[0].GroupSize == 1)
        {
            bForceAcceptTeam = true;
        }
        // End:0x137
        if(TryBalanceTeams(GameSize, TotalSkill / 2.0, BestTeam))
        {
            bBalanceSuccessfull = true;
        }
        // End:0x3A8
        else
        {
            BreakGroupSize = GroupList[0].GroupSize / 2;
            PCG.PCList.Length = 0;
            PCG.SkillRating = 0.0;
            PCG.GroupSize = 0;
            I = 0;
            J0x1CD:
            // End:0x2FE [Loop If]
            if(I < BreakGroupSize)
            {
                PCG.SkillRating += FoxPRI(GroupList[0].PCList[0].PlayerReplicationInfo).Skill;
                PCG.PCList[PCG.PCList.Length] = GroupList[0].PCList[0];
                GroupList[0].PCList.Remove(0, 1);
                ++ PCG.GroupSize;
                ++ I;
                // [Loop Continue]
                goto J0x1CD;
            }
            GroupList[0].GroupSize -= BreakGroupSize;
            GroupList[0].SkillRating -= PCG.SkillRating;
            GroupList[GroupList.Length] = PCG;
            GroupList.Sort(PCGroupSortDelegate);
        }
        // [Loop Continue]
        goto J0xBA;
    }
    I = 0;
    J0x3B6:
    // End:0x529 [Loop If]
    if(I < GroupList.Length)
    {
        // End:0x486
        if(BestTeam.Find(I) != -1)
        {
            J = 0;
            J0x3F9:
            // End:0x483 [Loop If]
            if(J < GroupList[I].PCList.Length)
            {
                GroupList[I].PCList[J].ServerChangeTeam(1);
                ++ J;
                // [Loop Continue]
                goto J0x3F9;
            }
        }
        // End:0x51B
        else
        {
            J = 0;
            J0x491:
            // End:0x51B [Loop If]
            if(J < GroupList[I].PCList.Length)
            {
                GroupList[I].PCList[J].ServerChangeTeam(0);
                ++ J;
                // [Loop Continue]
                goto J0x491;
            }
        }
        ++ I;
        // [Loop Continue]
        goto J0x3B6;
    }
    //return;    
}

function bool TryBalanceTeams(int TotalPlayers, float TeamGoalSkill, out array<int> BestTeam)
{
    local int GroupListIndex, TeamOneSize, TeamTwoSize, TeamGoalSize;
    local bool bAddTeamOne;
    local float TeamOneSkill, TeamTwoSkill;
    local bool bCanFitTeamOne, bCanFitTeamTwo;

    TeamGoalSize = (TotalPlayers / 2) + (TotalPlayers % 2);
    bAddTeamOne = true;
    GroupListIndex = 0;
    TeamOneSize = 0;
    TeamTwoSize = 0;
    TeamOneSkill = 0.0;
    TeamTwoSkill = 0.0;
    BestTeam.Length = 0;
    J0x7D:
    // End:0x2D9 [Loop If]
    if(GroupListIndex < GroupList.Length)
    {
        bCanFitTeamOne = (TeamOneSize + GroupList[GroupListIndex].GroupSize) <= TeamGoalSize;
        bCanFitTeamTwo = (TeamTwoSize + GroupList[GroupListIndex].GroupSize) <= TeamGoalSize;
        // End:0x145
        if(!bCanFitTeamOne && !bCanFitTeamTwo)
        {
            return false;
        }
        // End:0x20C
        if(bCanFitTeamOne && bAddTeamOne)
        {
            // End:0x20C
            if(!bCanFitTeamTwo || TeamOneSkill <= TeamTwoSkill)
            {
                TeamOneSkill += GroupList[GroupListIndex].SkillRating;
                TeamOneSize += GroupList[GroupListIndex].GroupSize;
                BestTeam.AddItem(GroupListIndex);
                ++ GroupListIndex;
            }
        }
        // End:0x2BF
        if(bCanFitTeamTwo && !bAddTeamOne)
        {
            // End:0x2BF
            if(!bCanFitTeamOne || TeamOneSkill >= TeamTwoSkill)
            {
                TeamTwoSkill += GroupList[GroupListIndex].SkillRating;
                TeamTwoSize += GroupList[GroupListIndex].GroupSize;
                ++ GroupListIndex;
            }
        }
        bAddTeamOne = !bAddTeamOne;
        // [Loop Continue]
        goto J0x7D;
    }
    return true;
    //return ReturnValue;    
}

// Export UFoxTeamBalance::execCalculateSize(FFrame&, void* const)
native function int CalculateSize(array<int> TryTeam);

function float CalculateSkill(array<int> TryTeam)
{
    local int I;
    local float ReturnSkill;

    I = 0;
    J0x0B:
    // End:0x6C [Loop If]
    if(I < TryTeam.Length)
    {
        ReturnSkill += GroupList[TryTeam[I]].SkillRating;
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return ReturnSkill;
    //return ReturnValue;    
}

delegate int PCGroupSortDelegate(PCGroup A, PCGroup B)
{
    // End:0x43
    if(A.GroupSize < B.GroupSize)
    {
        return -1;
    }
    // End:0xC3
    if(A.GroupSize == B.GroupSize)
    {
        // End:0xC3
        if(A.SkillRating < B.SkillRating)
        {
            return -1;
        }
    }
    return 0;
    //return ReturnValue;    
}

function DebugTeamBalance()
{
    local int PlayerCount, Size;
    local float Skill;
    local PCGroup PCG;


    J0x00:    // End:0x11D [Loop If]
    if(PlayerCount < 16)
    {
        // End:0x7A
        if((16 - PlayerCount) > 5)
        {
            Size = int((FRand() * float(5)) + float(1));
            PCG.GroupSize = Size;
            PlayerCount += Size;
        }
        // End:0xA3
        else
        {
            PCG.GroupSize = 1;
            ++ PlayerCount;
        }
        Skill = (FRand() * 5.0) * float(PCG.GroupSize);
        PCG.SkillRating = Skill;
        GroupList[GroupList.Length] = PCG;
        // [Loop Continue]
        goto J0x00;
    }
    SplitIntoTeams();
    //return;    
}

defaultproperties
{
    MaxSkillDifference=1.0
    MaxPartySize=-1
}